<?php

declare(strict_types=1);

namespace ConnectPay\Payment\Gateway\Command\Result;

use ConnectPay\Payment\Gateway\Config\Config;
use Magento\Framework\DataObject;
use Magento\Payment\Gateway\Command\ResultInterface;

class RedirectUrlResult extends DataObject implements ResultInterface
{
    public function get()
    {
        $data = $this->getData('response');
        if (array_key_exists('payment', $data)) {
            $paymentData = $data['payment'];
            if (array_key_exists(Config::KEY_REDIRECT_URL, $paymentData)) {
                return $paymentData[Config::KEY_REDIRECT_URL];
            }

        }
        return null;
    }
}
