<?php

declare(strict_types=1);

namespace ConnectPay\Payment\Gateway\Request;

use ConnectPay\Payment\Gateway\Config\Config;
use ConnectPay\Payment\Gateway\SubjectReader;

class IdentifiersDataBuilder extends AbstractDataBuilder
{
    /**
     * @var Config
     */
    private $config;

    /**
     * @param Config $config
     * @param SubjectReader $subjectReader
     */
    public function __construct(
        Config        $config,
        SubjectReader $subjectReader
    )
    {
        $this->config = $config;
        parent::__construct($subjectReader);
    }

    public function build(array $buildSubject): array
    {
        $paymentDO = $this->subjectReader->readPayment($buildSubject);
        $payment = $paymentDO->getPayment();

        return [
            Config::KEY_IDENTIFIERS => [
                Config::KEY_MERCHANT_REFERENCE => $payment->getId(),
                Config::KEY_END_TO_END_ID => 'NOTPROVIDED',
            ]
        ];
    }
}
