<?php

declare(strict_types=1);

namespace ConnectPay\Payment\Gateway\Response;

use ConnectPay\Payment\Gateway\Config\Config;
use ConnectPay\Payment\Gateway\SubjectReader;
use Magento\Payment\Gateway\Response\HandlerInterface;
use Magento\Sales\Api\OrderRepositoryInterface as OrderRepository;

class InitiatePaymentHandler implements HandlerInterface
{
    /**
     * @var SubjectReader
     */
    private $subjectReader;

    /**
     * @var OrderRepository
     */
    private $orderRepository;

    public function __construct(
        SubjectReader   $subjectReader,
        OrderRepository $orderRepository
    )
    {
        $this->subjectReader = $subjectReader;
        $this->orderRepository = $orderRepository;
    }

    public function handle(array $handlingSubject, array $response)
    {
        $paymentDO = $this->subjectReader->readPayment($handlingSubject);
        $cpPaymentId = $this->subjectReader->readPaymentId($response);
        $orderId = $paymentDO->getOrder()->getId();
        $order = $this->orderRepository->get($orderId);
        $payment = $order->getPayment();
        $payment->setData(Config::KEY_PAYMENT_ID, $cpPaymentId);
        $this->orderRepository->save($order);
    }
}
