<?php

declare(strict_types=1);

namespace ConnectPay\Payment\Model;

class ProviderMapper
{
    /**
     * @param array $data
     * @return array
     */
    public function getProviderData(array $data): array
    {
        $providerData = [];
        if (array_key_exists('providers', $data)) {
            $providersArray = $data['providers'];
            foreach ($providersArray as $providers) {
                if (array_key_exists('status', $providers)) {
                    if (array_key_exists('availability', $providers['status'])) {
                        $status = $providers['status']['availability'];
                        if ($status === 'active') {
                            $allowed = ['id', 'name'];
                            $providerData[] = array_intersect_key($providers, array_flip($allowed));
                        }
                    }
                }
            }
        }
        return $providerData;
    }
}
